require "util"


local constants = {
    type = "accumulator",
    name = "powerlimitizer",
    icon = "__Powerlimiter__/graphics/icons/powerlimitizer.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "powerlimitizer"},
    max_health = 150,
    corpse = "medium-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1, -1}, {1, 1}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "500kJ",  --5MJ
     -- usage_priority = "terciary",
      usage_priority = "terciary",
      input_flow_limit = {value=10, ext="kW"},			--"10kW",  --300kW
      output_flow_limit = {value=10, ext="kW"},			--"10kW",  --300kW
    },
    picture =
    {
      filename = "__Powerlimiter__/graphics/entity/powerlimitizer/powerlimitizer.png",
      priority = "extra-high",
      width = 124,
      height = 103,
      shift = {0.7, -0.2}
    },
    charge_animation =
    {
      filename = "__Powerlimiter__/graphics/entity/powerlimitizer/powerlimitizer-charge-animation.png",
      frame_width = 138,
      frame_height = 135,
      line_length = 8,
      frame_count = 24,
      shift = {0.482, -0.638},
      animation_speed = 0.5
    },
    charge_cooldown = 30,
    charge_light = {intensity = 0.3, size = 7},
    discharge_animation =
    {
      filename = "__Powerlimiter__/graphics/entity/powerlimitizer/powerlimitizer-discharge-animation.png",
      frame_width = 147,
      frame_height = 128,
      line_length = 8,
      frame_count = 24,
      shift = {0.395, -0.525},
      animation_speed = 0.5
    },
    discharge_cooldown = 60,
    discharge_light = {intensity = 0.7, size = 7}
}





for i = 0, 500 do -- no 0 its 10kW  no 499 its 5MW
	local power_step = 10	--in kW
    nextEntity = util.table.deepcopy(constants) -- just making a copy
    local modularName = nextEntity.name
	if i ~= 0 then
      nextEntity.order = modularName .. "-place"
      nextEntity.name = modularName .. "-" .. i
    else
      nextEntity.name = modularName
    end
    
	nextEntity.energy_source.input_flow_limit = power_step * (i) .. nextEntity.energy_source.input_flow_limit.ext
	
	nextEntity.energy_source.output_flow_limit = power_step * (i) .. nextEntity.energy_source.output_flow_limit.ext
	
	--nextEntity.icon = nextEntity.icon .. modularName .. ".png"  -- moved up
    --nextEntity.minable.result = modularName
    --nextEntity.energy_source.drain = (nextEntity.energy_source.drain.value * h) .. nextEntity.energy_source.drain.ext
    --nextEntity.energy_per_movement = power["tele_power_mk" .. h][i+1]
    --nextEntity.energy_per_movement = calc_power(h, i)
    --nextEntity.energy_per_rotation = nextEntity.energy_per_movement
	--nextEntity.platform_picture.sheet = nextEntity.platform_picture.sheet .. h .. ".png"
    data:extend({nextEntity})
 end

 
 data:extend({

--[[{   
   type = "accumulator",
    name = "dmg",
    icon = "__Powerlimiter__/graphics/icons/powerlimitizer.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "dmg"},
    max_health = 150,
    corpse = "medium-remnants",
    collision_box = {{-6.2, -6.2}, {6.2, 6.2}},
    selection_box = {{-6.5, -6.5}, {6.5, 6.5}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "500kJ",
      usage_priority = "terciary",
      input_flow_limit = "1kW",			
      output_flow_limit = "1000kW",			
    },
    picture =
    {
      filename = "__Powerlimiter__/graphics/entity/dmg/dmg.png",
      priority = "extra-high",
      width = 431,
      height = 431,
      shift = {0, 0}
    },
    --charge_animation =
   -- {
   --   filename = "__Powerlimiter__/graphics/entity/powerlimitizer/powerlimitizer-charge-animation.png",
   --   frame_width = 138,
   --   frame_height = 135,
   --   line_length = 8,
   --   frame_count = 24,
  --    shift = {0.482, -0.638},
  --    animation_speed = 0.5
  --  },
    charge_cooldown = 30,
 --   charge_light = {intensity = 0.9, size = 21},  --intensity = 0.3, size = 7},
 --   discharge_animation =
 --   {
 --     filename = "__Powerlimiter__/graphics/entity/powerlimitizer/powerlimitizer-discharge-animation.png",
 --     frame_width = 147,
  --    frame_height = 128,
  --    line_length = 8,
  --    frame_count = 24,
 --     shift = {0.395, -0.525},
 --     animation_speed = 0.5
 --   },
    discharge_cooldown = 60
 --   discharge_light = {intensity = 2.1, size = 21}    --{intensity = 0.7, size = 7}

}	]]--



  {
    type = "solar-panel",
    name = "dmg",
    icon = "__Powerlimiter__/graphics/icons/dmg.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "dmg"},
    max_health = 100,
    corpse = "big-remnants",
    collision_box = {{-3.2, -3.2}, {3.2, 3.2}},
    selection_box = {{-3.5, -3.5}, {3.5, 3.5}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output",
	  emissions = 0.02 / 1.5
    },
    picture =
    {
      filename = "__Powerlimiter__/graphics/entity/dmg/dmg.png",
      priority = "extra-high",
      width = 211,
      height = 211,
      shift = {0, 0}
    },
    production = "1500kW"
  },
  {
    type = "solar-panel",
    name = "dmg2",
    icon = "__Powerlimiter__/graphics/icons/dmg2.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "dmg2"},
    max_health = 100,
    corpse = "big-remnants",
    collision_box = {{-3.2, -3.2}, {3.2, 3.2}},
    selection_box = {{-3.5, -3.5}, {3.5, 3.5}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output",
	  emissions = 0.02 / 1.5
    },
    picture =
    {
      filename = "__Powerlimiter__/graphics/entity/dmg/dmg2.png",
      priority = "extra-high",
      width = 211,
      height = 211,
      shift = {0, 0}
    },
    production = "7500kW" -- 10*1500=15000 * wspolczynnik *0,5 = 7500
  },
  {
    type = "solar-panel",
    name = "dmg3",
    icon = "__Powerlimiter__/graphics/icons/dmg3.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "dmg3"},
    max_health = 100,
    corpse = "big-remnants",
    collision_box = {{-3.2, -3.2}, {3.2, 3.2}},
    selection_box = {{-3.5, -3.5}, {3.5, 3.5}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output",
	  emissions = 0.02 / 1.5
    },
    picture =
    {
      filename = "__Powerlimiter__/graphics/entity/dmg/dmg3.png",
      priority = "extra-high",
      width = 211,
      height = 211,
      shift = {0, 0}
    },
    production = "55000kW" -- 10*7500=75000 * wspolczynnik *0,5 = 37500    lub   100*1500= 150000*0,5 = 75000   średnia= (37500+75000)/2=112500/2=56250kW ~55000kW
  }  
  

 })
 